<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['setting:carousel:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['setting:carousel:edit']"
              >修改</el-button
            >
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['setting:carousel:remove']"
              >删除</el-button
            >
          </el-col>
          <!--          <el-col :span="1.5">-->
          <!--            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['setting:carousel:export']">导出</el-button>-->
          <!--          </el-col>-->
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="carouselList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="序号" align="center" prop="id" v-if="true" />
        <el-table-column label="图片" align="center" prop="ossidUrl" width="100">
          <template #default="scope">
            <image-preview :src="scope.row.ossidUrl" :width="50" :height="50" />
          </template>
        </el-table-column>
        <el-table-column label="排序" align="center" prop="sort" />
        <el-table-column label="备注" align="center" prop="note" />
        <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['setting:carousel:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['setting:carousel:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改轮播图设置对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="carouselFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="图片" prop="ossid">
          <image-upload v-model="form.ossid" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Carousel" lang="ts">
import { listCarousel, getCarousel, delCarousel, addCarousel, updateCarousel } from '@/api/setting/carousel';
import { CarouselVO, CarouselQuery, CarouselForm } from '@/api/setting/carousel/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const carouselList = ref<CarouselVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const carouselFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: CarouselForm = {
  id: undefined,
  ossid: undefined,
  sort: undefined,
  note: undefined
};
const data = reactive<PageData<CarouselForm, CarouselQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    params: {}
  },
  rules: {
    id: [{ required: true, message: '序号不能为空', trigger: 'blur' }],
    ossid: [{ required: true, message: '图片不能为空', trigger: 'blur' }],
    sort: [{ required: true, message: '排序不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询轮播图设置列表 */
const getList = async () => {
  loading.value = true;
  const res = await listCarousel(queryParams.value);
  carouselList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  carouselFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: CarouselVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加轮播图设置';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: CarouselVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getCarousel(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改轮播图设置';
};

/** 提交按钮 */
const submitForm = () => {
  carouselFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateCarousel(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addCarousel(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: CarouselVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除轮播图设置编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delCarousel(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'setting/carousel/export',
    {
      ...queryParams.value
    },
    `carousel_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
